import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.IOException;

import javax.swing.*;
import javax.swing.text.BadLocationException;
import javax.swing.text.Highlighter;

public class SemanticGUI {
	private static String Search(String query) throws IOException {

		return HelloSemanticWeb.runQuery(query);
	}

	private static void createAndShowGUI() {
		// Create and set up the window.
		JFrame frame = new JFrame("WritersHelper v0.1");
		frame.setSize(700, 500);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		final JEditorPane epane = new JEditorPane();
		final JEditorPane opane = new JEditorPane();
		opane.setEditable(false);
		JScrollPane topSP = new JScrollPane(epane);
		JScrollPane botSP = new JScrollPane(opane);
		opane.setBackground(new Color(1.0f, 1.0f, 0.81f));
		epane.addKeyListener(new KeyListener() {
			@Override
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_F5) {

					String query = "";

					if (epane.getHighlighter().getHighlights().length == 0) {

						String[] words = {};

						try {

							words = epane.getText(0, epane.getCaretPosition())
									.split("\\s+");

						} catch (BadLocationException e1) {

							e1.printStackTrace();

						}

						if (words.length > 0)

							query = words[words.length - 1];

					} else {
						Highlighter.Highlight item = epane.getHighlighter()
								.getHighlights()[0];
						int start = item.getStartOffset();
						int end = item.getEndOffset();
						try {
							query = epane.getText(start, end - start);
						} catch (BadLocationException e1) {
							e1.printStackTrace();
						}
					}
					try {
						String searchOutput = Search(query);
						opane.setText(searchOutput);
						opane.setCaretPosition(0);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}

				}
			}

			@Override
			public void keyReleased(KeyEvent e) {
			}

			@Override
			public void keyTyped(KeyEvent e) {
			}
		});

		opane.addKeyListener(new KeyListener() {
			@Override
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_F5) {

					String query = "";

					if (opane.getHighlighter().getHighlights().length == 0) {

						String[] words = {};

						try {

							words = opane.getText(0, opane.getCaretPosition())
									.split("\\s+");

						} catch (BadLocationException e1) {

							e1.printStackTrace();

						}

						if (words.length > 0)

							query = words[words.length - 1];

					} else {
						Highlighter.Highlight item = opane.getHighlighter()
								.getHighlights()[0];
						int start = item.getStartOffset();
						int end = item.getEndOffset();
						try {
							query = opane.getText(start, end - start);
						} catch (BadLocationException e1) {
							e1.printStackTrace();
						}
					}
					try {
						String searchOutput = Search(query);
						opane.setText(searchOutput);
						opane.setCaretPosition(0);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}

				}
			}

			@Override
			public void keyReleased(KeyEvent e) {
			}

			@Override
			public void keyTyped(KeyEvent e) {
			}
		});
		GridLayout gl = new GridLayout(2, 1);
		frame.getContentPane().setLayout(gl);
		frame.getContentPane().add(topSP, BorderLayout.NORTH);
		frame.getContentPane().add(botSP, BorderLayout.SOUTH);
		frame.setVisible(true);
	}

	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				createAndShowGUI();
			}
		});
	}
}